unit LastDetailInGroup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ppCtrls, ppPrnabl, ppClass, ppBands, daDataView, daQueryDataView,
  daDBBDE, ppModule, daDataModule, ppCache, ppComm, ppRelatv, ppProd, ppReport,
  StdCtrls;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    daDataModule1: TdaDataModule;
    daBDEQueryDataView1: TdaBDEQueryDataView;
    ppGroup1: TppGroup;
    ppGroupHeaderBand1: TppGroupHeaderBand;
    ppGroupFooterBand1: TppGroupFooterBand;
    ppDBText1: TppDBText;
    ppDBText2: TppDBText;
    ppDBText3: TppDBText;
    ppLine1: TppLine;
    ppLine2: TppLine;
    Button1: TButton;
    daBDEQueryDataView2: TdaBDEQueryDataView;
    ppDBText4: TppDBText;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ppDetailBand1BeforeGenerate(Sender: TObject);
    procedure ppDetailBand1BeforePrint(Sender: TObject);
    procedure ppGroup1AfterGroupBreak(Sender: TObject);
  private
    FDetailCount: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ppDBPipe;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FDetailCount := 0;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ppReport1.Print;

end;

procedure TForm1.ppDetailBand1BeforeGenerate(Sender: TObject);
begin
  FDetailCount := FDetailCount + 1;

end;

procedure TForm1.ppDetailBand1BeforePrint(Sender: TObject);
var
  liDetailCount: Integer;
begin

  liDetailCount := daBDEQueryDataView2.DataPipelines[0]['COUNT(*)'];

  ppLine1.Visible := liDetailCount <> FDetailCount + 1;

end;

procedure TForm1.ppGroup1AfterGroupBreak(Sender: TObject);
begin
  FDetailCount := 0;
  daBDEQueryDataView2.DataPipelines[0].Next;

end;

end.
